/*
  CEC14 Test Function Suite for Single Objective Optimization
  BO Zheng (email: zheng.b1988@gmail.com) 
  Dec. 5th 2013
*/




import java.io.File;
import java.util.Scanner;



public class testfunc {
	
	final double INF = 1.0e99;
	final double EPS = 1.0e-14;
	final double E  = 2.7182818284590452353602874713526625;
	final double PI = 3.1415926535897932384626433832795029;
	
	double[] OShift,M,y,z,x_bound;
	int ini_flag,n_flag,func_flag;
	int[] SS;
	
	
	//double sphere_func (double[] , double , int , double[] ,double[] ,int ,int); /* Sphere */
	//double ellips_func(double[] , double , int , double[] ,double[] ,int ,int); /* Ellipsoidal */
	//double step_func(double[] , double , int , double[] ,double[] ,int ,int); /* Step */
	//double ackley_func (double[] , double , int , double[] ,double[] ,int ,int); /* Ackley's */
	//double griewank_func (double[] , double , int , double[] ,double[] ,int ,int); /* Griewank's  */
	//double rosenbrock_func (double[] , double , int , double[] ,double[] ,int ,int); /* Rosenbrock's */
	//double rastrigin_func (double[] , double , int , double[] ,double[] ,int ,int); /* Rastrigin's  */

	//void shiftfunc (double[] , double[] , int ,double[] )
	//void rotatefunc (double[] , double[] , int ,double[] )
	//void sr_func (double[] .double[] ,int ,double[] ,double[] ,double ,int ,int )/* shift and rotate*/
	
	
	
	void test_func(double[] x, double[] f, int nx, int mx,int func_num)throws Exception{
		
		int cf_num=10,i;
		if (ini_flag==1)
		{
			if ((n_flag!=nx)||(func_flag!=func_num))
			{
				ini_flag=0;
			}
		}
		
		
		if (ini_flag==0)
		{
			y=new double[nx];
			z=new double[nx];
			x_bound=new double[nx];
			for (i=0; i<nx; i++)
				x_bound[i]=100.0;

			if (!(nx==2||nx==10||nx==20||nx==30))
			{
				System.out.println("\nError: Test functions are only defined for D=2,10,20,30.\n");
			}

			/* Load Matrix M*/
			File fpt = new File("input_data/M_"+func_num+"_D"+nx+".txt");//* Load M data *
			Scanner input = new Scanner(fpt);
			if (!fpt.exists())
			{
			    System.out.println("\n Error: Cannot open input file for reading ");
			}
			
			
			
				
				M = new double[nx*nx];
			
				for (i=0; i<nx*nx; i++)
				{
					M[i]=input.nextDouble();
				}
			
			input.close();
			
			/* Load shift_data */
			fpt=new File("input_data/shift_data_"+func_num+".txt");
			input = new Scanner(fpt);
			if (!fpt.exists())
			{
				System.out.println("\n Error: Cannot open input file for reading ");
			}
			
			OShift=new double[cf_num*nx];
		
				for(i=0;i<nx;i++)
				{
					OShift[i]=input.nextDouble();
				}
		
			input.close();

			n_flag=nx;
			func_flag=func_num;
			ini_flag=1;
			//printf("Function has been initialized!\n");
			
			
			double[] t = new double[nx];
			
			for (i = 0; i < mx; i++)
			{
				
				for ( int j=0; j<nx; j++){
					t[j] = x[i*nx+j];
				}
				
				
				switch(func_num)
				{
				case 1:	
					f[i]=sphere_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=100.0;
					break;
				case 2:	
					f[i]=ellips_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=200.0;
					break;
				case 3:	
					f[i]=ellips_func(t,f[i],nx,OShift,M,1,1);
					f[i]+=300.0;
					break;
				case 4:	
					f[i]=step_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=400.0;
					break;
				case 5:	
					f[i]=ackley_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=500.0;
					break;
				case 6:
					f[i]=griewank_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=600.0;
					break;
				case 7:
					f[i]=rosenbrock_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=700.0;
					break;
				case 8:	
					f[i]=rastrigin_func(t,f[i],nx,OShift,M,1,0);
					f[i]+=800.0;
					break;
				default:
					System.out.println("\nError: There are only 28 test functions in this test suite!\n");
					f[i] = 0.0;
					break;
				}
				
			}

			
		}
	}
		
		
		
		double sphere_func (double[] x, double f, int nx, double[] Os,double[] Mr,int s_flag, int r_flag) /* Sphere */
		{
			int i;
			sr_func (x, z, nx, Os, Mr, 1.0, s_flag, r_flag); /* shift and rotate */	

							
			f = 0.0;
		    for (i=0; i<nx; i++)
		    {
		    	f += z[i]*z[i];
		    }
		    
		    return f;
		}
		
		double ellips_func (double[] x, double f, int nx, double[] Os,double[] Mr,int s_flag,int r_flag) /* Ellipsoidal */
		{
		    int i;
		    f = 0.0;
		    sr_func(x,z,nx,Os,Mr,1.0,s_flag,r_flag);/*shift and rotate*/
		        
		    for (i=0; i<nx; i++)
		    {
		        f += Math.pow(10.0,6.0*i/(nx-1))*z[i]*z[i];
		    }
		    return f;
		}
		
		double step_func (double[] x, double f, int nx, double[] Os,double[] Mr, int s_flag, int r_flag) /* Step */
		{
		    int i;
			
			sr_func (x, z, nx, Os, Mr,1.0, s_flag, r_flag); /* shift and rotate */

			f = 0.0;
			for (i=0; i<nx; i++)
			{
		       f += Math.pow(Math.floor(z[i]+0.5),2.0);
			}
			
			return f;
		}
		
		double ackley_func (double[] x, double f, int nx, double[] Os,double[] Mr,int s_flag,int r_flag) /* Ackley's  */
		{
		    int i;
		    double sum1, sum2;
		    sum1 = 0.0;
		    sum2 = 0.0;
		    
		    sr_func(x,z,nx,Os,Mr,1.0,s_flag,r_flag);/*shift and rotate*/ 		
		    
		    for (i=0; i<nx; i++)
		    {
		        sum1 += z[i]*z[i];
		        sum2 += Math.cos(2.0*PI*z[i]);
		    }
		    sum1 = -0.2*Math.sqrt(sum1/nx);
		    sum2 /= nx;
		    f =  E - 20.0*Math.exp(sum1) - Math.exp(sum2) +20.0;
		    
		    return f;
		}
		
		double griewank_func (double[] x, double f, int nx, double[] Os,double[] Mr,int s_flag,int r_flag) /* Griewank's  */
		{
		    int i;
		    double s, p;

		    sr_func(x,z,nx,Os,Mr,600.0/100.0,s_flag,r_flag);/*shift and rotate*/ 

		    s = 0.0;
		    p = 1.0;
		    for (i=0; i<nx; i++)
		    {
		        s += z[i]*z[i];
		        p *= Math.cos(z[i]/Math.sqrt(1.0+i));
		    }
		    f = 1.0 + s/4000.0 - p;
		    
		    return f;
		}
		
		double rosenbrock_func (double[] x, double f, int nx, double[] Os,double[] Mr,int s_flag,int r_flag) /* Rosenbrock's */
		{
		    int i;
			double tmp1,tmp2;
			f = 0.0;
		    sr_func(x,z,nx,Os,Mr,2.048/100.0,s_flag,r_flag);/*shift and rotate*/
		    z[0] +=1.0; //shift to origin
		    for (i=0; i<nx-1; i++)
		    {
				z[i+1] += 1.0; //shift to orgin
		    	tmp1=z[i]*z[i]-z[i+1];
				tmp2=z[i]-1.0;
		        f += 100.0*tmp1*tmp1 +tmp2*tmp2;
		    }
		    
		    
		    return f;
		}
		
		double rastrigin_func (double[] x, double f, int nx, double[] Os,double[] Mr,int s_flag,int r_flag) /* Rastrigin's  */
		{
		    int i;
			f=0.0;
		    
			sr_func(x,z,nx,Os,Mr,5.12/100.0,s_flag,r_flag);/*shift and rotate*/ 

			for(i=0;i<nx;i++)
			{
				f += (z[i]*z[i] - 10.0*Math.cos(2.0*PI*z[i]) + 10.0);
			}
		    
		    return f;
		}
		
		
							
			
		
		
		
		void shiftfunc (double[] x, double[] xshift, int nx,double[] Os)
		{
			int i;
		    for (i=0; i<nx; i++)
		    {
		        xshift[i]=x[i]-Os[i];
		    }
		}
		
		
		void rotatefunc (double[] x, double[] xrot, int nx,double[] Mr)
		{
			int i,j;
		    for (i=0; i<nx; i++)
		    {
		        xrot[i]=0;
					for (j=0; j<nx; j++)
					{
						xrot[i]=xrot[i]+x[j]*Mr[i*nx+j];
					}
		    }
		}
		
		void sr_func (double[] x, double[] sr_x, int nx, double[] Os, double[] Mr, double sh_rate, int s_flag, int r_flag)
		{
			int i,j;
			if (s_flag==1)
			{
				if (r_flag==1)
				{	
					shiftfunc(x, y, nx, Os);
					for (i=0; i<nx; i++)//shrink to the orginal search range
					{
						y[i]=y[i]*sh_rate;
					}
					rotatefunc(y, sr_x, nx, Mr);
				}
				else
				{
					shiftfunc(x, sr_x, nx, Os);
					for (i=0; i<nx; i++)//shrink to the orginal search range
					{
						sr_x[i]=sr_x[i]*sh_rate;
					}
				}
			}
			else
			{	

				if (r_flag==1)
				{	
					for (i=0; i<nx; i++)//shrink to the orginal search range
					{
						y[i]=x[i]*sh_rate;
					}
					rotatefunc(y, sr_x, nx, Mr);
				}
				else
				
				{
					for (j=0; j<nx; j++)//shrink to the orginal search range
					{
						sr_x[j]=x[j]*sh_rate;
					}
				}
			}

		
		
		
		
		
		
	}
	
	
	
}
